package turgen.playlist;
import java.io.*;
import turgen.generator.PulseCrate;

/**
 * Abstract playlist item
 */

public abstract class AbstractPlayListItem implements Serializable {
    
    /**  Input file*/
    public String inFile=null; 
    /**  Output file*/
    public String outFile=null;
    /** Plugin class*/
    public String pluginClass=null;
    /**Pulses*/
    public PulseCrate pulses=null;
    
    /**Get String representation
     *@return String representation of playlist item
     */
    public abstract String toString();
    
    /*Validation of playlist item
     * @return true when playlist item is valid, otherwise false
     */
    public abstract boolean validate();
    
}
